<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\AnswerRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\User;
use App\Question;
use App\SessionReservation;

class PatientSessionController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/patientsessions';
    /** View folder */
    private $viewDirectory= 'admin.patientsessions.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('patientsessions.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the patientsessions.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $user = \Auth::user();
        $query = SessionReservation::where('patient_id',$user->id)->where('dating','!=',NULL)->orderBy('id', 'DESC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->session) {
            $query->where('session', 'LIKE', '%'.$request->session.'%');
        }
        if ($request->patient) {
            $query->whereIn('user_id', patient($request->patient));
        }
       


        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $patientsessions= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('patientsessions'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('patientsessions.store');
        $head = metaFields('patientsessions', 'add_new', getCurrentLocale()) ?? __('patientsessions.new');
        $questions = Question::cursor();
        $patients = User::where('role_id','6')->get();
       

        return view( $this->viewDirectory.'form', compact('action','questions', 'head','patients') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param AnswerRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(AnswerRequest $request) :RedirectResponse
    {
        
        $answer= Answer::create($request->all());
       
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  Answer  $answer
     * @return View
     */
    public function edit(Answer $answer): View
    {
        $action= route('patientsessions.update', $answer->id);
        $head = metaFields('patientsessions', 'edit', getCurrentLocale()) ?? __('patientsessions.edit');
        $questions = Question::cursor();
        $patients = User::where('role_id','6')->get();


        return view( $this->viewDirectory.'form', compact('answer','questions' ,'action', 'head','patients') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  AnswerRequest  $request
     * @param  Answer  $systemfood
     * @return RedirectResponse|Redirector
     */
        public function update(AnswerRequest $request, Answer $answer) :RedirectResponse
    {
        
        $answer->update($request->all());

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = Answer::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Answer::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Answer::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = Answer::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = Answer::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
